function pop = create_population(NVARS,FitnessFcn,options,bestNeig,Neighbor)
%CREATE_POPULATION Creates a population of chromosome.
%   POP = CREATE_POPULATION(NVARS,FITNESSFCN,OPTIONS) creates a population
%  POP each element being a cell array of length NVARS. Each cell array 
%  is initialized with numbers between 1 and nclust  
%
%   The arguments to the function are 
%     NVARS: Number of variables 
%     FITNESSFCN: Fitness function 
%     OPTIONS: Options structure used by the GA

%   Copyright 2004-2007 The MathWorks, Inc.
%   $Revision: 1.1.4.2 $  $Date: 2007/06/14 05:06:18 $

totalPopulationSize = sum(options.PopulationSize);

pop = zeros(totalPopulationSize,NVARS);
rand('twister',sum(1000*clock));
for i = 1:totalPopulationSize
    %disp('cromosoma random')
    chrom = fix(NVARS*rand(NVARS,1))+1;
    for k=1:NVARS
        position=bestNeig(k);
       %position = ceil(size(Neighbor{k},2)*rand);
        chrom(k)= Neighbor{k}(position);
    end
    
   
    pop(i,:) = chrom;
end
end