
function mutationChildren = mutate_cluster(parents ,options,NVARS, ...
    FitnessFcn, state, thisScore,thisPopulation,mutationRate,Neighbor)
%
%   The arguments to the function are 
%     PARENTS: Parents chosen by the selection function
%     OPTIONS: Options structure created from GAOPTIMSET
%     NVARS: Number of variables 
%     FITNESSFCN: Fitness function 
%     STATE: State structure used by the GA solver 
%     THISSCORE: Vector of scores of the current population 
%     THISPOPULATION: Matrix of individuals in the current population
%     MUTATIONRATE: Rate of mutation
%     Neighbor a cell array containing the neighbors of each node


mutationChildren = zeros(length(parents),NVARS);

%mutationChildren = cell(length(parents),1);
%disp('sono in mutation')

for i=1:length(parents)
    if (mutationRate>rand)
   
        child = thisPopulation(parents(i),:);
        
        rand('twister',sum(100*clock));
        pos = ceil(NVARS*rand);
       
        valuepos=ceil(size(Neighbor{pos},2)*rand);

        child(pos) = Neighbor{pos}(valuepos);
        %mutationChildren{i} = child; 
        mutationChildren(i,:)=child;
    else
       % mutationChildren{i} = thisPopulation{parents(i)};
       mutationChildren(i,:) = thisPopulation(parents(i),:);
    end
end

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%function mutationChildren = mutate_cluster(parents ,options,NVARS, ...
   % FitnessFcn, state, thisScore,thisPopulation,mutationRate,M)
%   MUTATE_PERMUTATION Custom mutation function for traveling salesman.
%   MUTATIONCHILDREN = MUTATE_PERMUTATION(PARENTS,OPTIONS,NVARS, ...
%   FITNESSFCN,STATE,THISSCORE,THISPOPULATION,MUTATIONRATE) mutate the
%   PARENTS to produce mutated children MUTATIONCHILDREN.
%
%   The arguments to the function are 
%     PARENTS: Parents chosen by the selection function
%     OPTIONS: Options structure created from GAOPTIMSET
%     NVARS: Number of variables 
%     FITNESSFCN: Fitness function 
%     STATE: State structure used by the GA solver 
%     THISSCORE: Vector of scores of the current population 
%     THISPOPULATION: Matrix of individuals in the current population
%     MUTATIONRATE: Rate of mutation

%   Copyright 2004 The MathWorks, Inc.
%   $Revision: 1.1.4.1 $  $Date: 2004/03/26 13:26:11 $

% 

% mutationChildren = zeros(length(parents),NVARS);
% 
% for i=1:length(parents)
%     if (mutationRate>rand)
%         %pos = fix(NVARS*rand)+1;
%         
%         rand('twister',sum(100*clock));
%         pos = ceil(NVARS*rand);
%    
%          child = thisPopulation(parents(i),:);
%         
%         neighbors=zeros(1,1);
%         nn=1;
%         for j=1:NVARS %si memorizzano in neignbors gli indici 
%             if (M(pos,j)==1) %dei vicini di pos
%                 neighbors(1,nn)=j;
%                 nn=nn+1;
%             end
%         end
%         %neighbors
%        %neighbors(1,nn)=pos;
%         valuepos=fix((size(neighbors,2))*rand)+1; %si prende a caso  uno
%         child(pos) = neighbors(valuepos);%dei vicini di pos e si sostituisce
%                       %in child(pos)
%        
%         mutationChildren(i,:)=child;
%     else
%          mutationChildren(i,:) = thisPopulation(parents(i),:);
%     end
% end
% %celldisp(mutationChildren)
% %celldisp(thisPopulation)